function earlystoppedreturn = RGLVQ_progresser(par, variables, output, where)
%
% control actions during each iteration of the fminlbfgs optimization
%
% Conditions of GNU General Public License, version 2 and BSD License apply.
% See file 'license-gpl2.txt' and 'BSD_license.txt' enclosed in this package.
% Programs are not for use in critical applications!
% Kerstin Bunte based on the code from Marc Strickert
%

if sum(where == 'iter') < 4
    par.earlystopped = false;
    earlystoppedreturn = par.earlystopped;
    return
end

par.earlystopped = exist ('stop','file') > 0;
earlystoppedreturn = par.earlystopped;

if par.earlystopped 
    delete('stop');
    return
end

if isempty(par.threshstop) 
    return
end


if par.threshstop > 0  % early stopping by simple thresholding: if too good: stop
    par.earlystopped = output.fval < threshstop;  % close to perfect
    earlystoppedreturn = earlystopped;
    if par.earlystopped
      'early stopped'
      return
    end
end

if isempty(par.useEarlyStopping)
    return
end

%%% early stopping
variables = reshape(variables, par.iPrototypes,par.N);
dErrorEstimate = par.fErrorFctPtr(variables);
if isempty(par.last) 
    par.penalty = -15;  % penalty counter, skip first 15 iterations (burn-in phase)
    par.last = dErrorEstimate;
else
      par.penalty = par.penalty + 1;
      if par.penalty > 0 && par.last >= 0.9 
        par.earlystopped = true;
        earlystoppedreturn = par.earlystopped;
        'early stopped'
        return
      end
end
earlystoppedreturn = par.earlystopped;