function distParNeuronsToData = dist_rel_neurons_to_data_par_alpha( Distances, vAlpha, iPointIndex )

%
% Determines gradient for the alpha parameter for the distances of 
% dissimilarities between relational neurons and data on which they are defined
%
% Distances   ... (m x m)-Matrix of dissimilarities between data points
% vAlpha      ... single alpha vector for neuron j (1 x m)-Matrix of relational neuron
% iPointIndex ... the point (k) the gradient calculation is based on
%
% Returns the gradient to \alpha_j with respect to all i calculated on d(k,j)
%
% Use squared distances to compare with other methods on euclidean distances !
%
% Frank-Michael Schleif (c) 2011
%
distParNeuronsToData = Distances(iPointIndex,:) - (vAlpha * Distances);

%mTemp                = Distances - 0.5 * cNeurons(jNeuronIndex,iPointIndex) * Distances;
%distParNeuronsToData = mTemp(:,iPointIndex);
%[~,m]                = size( cNeurons );
%for(i=1:m)
%	vAlpha0          = vAlpha;
%    vAlpha0(i)       = 0;
%    mTerm(i)         = sum(vAlpha0 .* Distances(i,:));
%end
%mTerm                = sum(Distances .* repmat(vAlpha',1,m) .* (~diag(ones(m,1))));

%mTerm=bsxfun(@times,Distances,vAlpha');
%mTerm(1:n+1:n*n) = 0;
%mTerm=sum(mTerm);
%mTerm                = mTerm +  (diag(Distances) .* vAlpha')';
%distParNeuronsToData = Distances(iPointIndex,:) - mTerm;
